#include<iostream>
#include<iomanip>
#include<vector>
#define MAXN 200000
#define MAXQ 100000
using namespace std;
int signs[MAXN+1],dist[MAXN+1];
vector <pair <int, int> > queries[MAXN+1];
double ans[MAXQ];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n >> dist[n] ;
    int prv=0;
    for (int i=0; i<n; i++) {
        cin >> dist[i] >> signs[i] ;
        dist[i]-=prv;
        prv+=dist[i];
    }
    dist[n]-=prv;
    int q;
    cin >> q ;
    for (int i=0; i<q; i++) {
        int pos,sign;
        cin >> pos >> sign ;
        pos--;
        queries[pos].push_back({sign, i});
    }


    vector <int> active;
    active.push_back(120);
    double time=0;
    vector <int> removed;
    for (int i=0; i<=n; i++) {
        for (auto [sign, ind] : queries[i]) {
            double tmp=signs[i];
            signs[i]=sign;
            for (int j=i; j<=n; j++) {
                time+=double(dist[j])/active.back();
                if (signs[j]!=-1) active.push_back(signs[j]);
                else {
                    removed.push_back(active.back());
                    active.pop_back();
                }
            }
            ans[ind]=time;
            for (int j=n; j>=i; j--) {
                if (signs[j]!=-1) active.pop_back();
                else {
                    active.push_back(removed.back());
                    removed.pop_back();
                }
                time-=double(dist[j])/active.back();
            }
            signs[i]=tmp;
        }
        time+=double(dist[i])/active.back();
        if (signs[i]!=-1) active.push_back(signs[i]);
        else active.pop_back();
    }

    for (int i=0; i<q; i++) {
        cout << std::fixed << std::setprecision(6) << ans[i] << "\n";
    }
    return 0;
}
